django/appointment/urls.py
from django.conf.urls import url
from django.urls import path

from . import views

app_name = 'appointment'
urlpatterns = [
    path('', views.index, name="index"),
    path('<int:appointment_id>', views.appointment_details, name="appointment_details"),
    path('<int:appointment_id>/result/<str:decision>/', views.result, name="result"),
    path('<int:appointment_id>/queue_list/', views.queue_list, name="queue_list"),
    path('<int:appointment_id>/delete_from_queue_list/<int:queue_id>', views.delete_queue_record,
         name="delete_queue_record"),
    path('<int:appointment_id>/queue_list/export', views.queue_list_export, name="queue_list_export"),
    url(r'^group-autocomplete/$', views.GroupAutocomplete.as_view(), name='group-autocomplete'),
    url(r'^subjects-autocomplete/$', views.SubjectsAutocomplete.as_view(), name='subjects-autocomplete'),
    path('add/', views.edit_appointment, name="add_appointment"),
    path('edit/<int:appointment_id>/', views.edit_appointment, name="edit_appointment"),
    path('delete/<int:appointment_id>/', views.delete_appointment, name="delete_appointment"),
]

django/ippo/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.urls import path
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import RedirectView
from documents.views import protected_view
from ecm.views import protected_view as ecm_view
from django.views.static import serve

urlpatterns = [
                  url(r'^favicon\.ico$', RedirectView.as_view(url='/static/main/images/ippo.ico')),
                  path('admin/', admin.site.urls),
                  path('', include('main.urls')),
                  path('diplomas/', include('diplomas.urls')),
                  path('appointments/', include('appointment.urls')),
                  path('news/', include('news.urls')),
                  url(r'^ckeditor/', include('ckeditor_uploader.urls')),
                  path('subjects/', include('subjects.urls')),
                  path('documents/', include('documents.urls')),
                  path('schedule/', include('schedule.urls')),
                  path('people/', include('people.urls')),
                  path('library/', include('library.urls')),
                  url(r'^select2/', include('django_select2.urls')),
              ] + static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT
) + static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT
)
#
# if settings.DEBUG:
#     urlpatterns += [
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.MEDIA_URL),
#             serve,
#             {"document_root": settings.MEDIA_ROOT, "show_indexes": True}
#         ),
#         url(
#             r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
#             serve,
#             {"document_root": settings.PROTECTED_MEDIA_ROOT, "show_indexes": True}
#         ),
#     ]
# else:
urlpatterns += [
    # url(
    #     r"^{}/(?P<path>.*)$".format(settings.PROTECTED_MEDIA_URL),
    #     protected_view
    # ),
    url(r'^protected/ecm/(?P<path>.*)$', ecm_view),
    url(r'^protected/(?P<path>.*)$', protected_view),
]

django/main/urls.py
from django.urls import path
from . import views

app_name = 'main'

urlpatterns = [
    path('', views.index, name="home"),
    path('about-<str:sub_cat>', views.about, name="about"),
    path('feedback', views.feedback, name="feedback"),
    path('teacher/<int:teacher_id>', views.about_teacher, name="teacher"),
    path('worker/<int:worker_id>', views.about_worker, name="worker"),
]

django/appointment/models.py
import datetime

from django.core import validators
from django.db import models
from django.utils.formats import date_format
from django.utils.timezone import now

from people.models import Student, Teacher, Tutor
from subjects.models import Subject


class Category(models.Model):
    name = models.CharField('Название', max_length=64, unique=True)

    class Meta:
        verbose_name = "Категория"
        verbose_name_plural = "Категории"
        ordering = ['name']

    def __str__(self):
        return self.name


class Appointment(models.Model):
    available = models.BooleanField(verbose_name='Доступна для записи', default=True)
    name = models.CharField(max_length=128, verbose_name='Название')
    teachers = models.ManyToManyField(Teacher, verbose_name='Преподаватели')
    tutors = models.ManyToManyField(Tutor, verbose_name='Тьюторы')
    start = models.DateTimeField(verbose_name='Начало', default=now)
    finish = models.TimeField(verbose_name='Конец', default=datetime.time(21, 0, 0))
    interval = models.TimeField(verbose_name='Время на одного студента', default=datetime.time(0, 0, 0),
                                help_text='Только одно из этих полей должно иметь значение, отличное от нуля')
    max = models.SmallIntegerField(verbose_name='Максимум студентов',
                                   validators=[validators.MaxValueValidator(100),
                                               validators.MinValueValidator(0)],
                                   default=30,
                                   help_text='Только одно из этих полей должно иметь значение, отличное от нуля')
    instruction = models.TextField(verbose_name='Указания', max_length=262144, blank=True)
    categories = models.ManyToManyField(Category, verbose_name='Категории')
    subjects = models.ManyToManyField(Subject, verbose_name='Предметы')

    def save(self, *args, **kwargs):
        if self.interval != datetime.time(0, 0, 0):
            self.max = 0
        super(Appointment, self).save(*args, **kwargs)

    def get_weekday(self):
        return date_format(self.start, 'l')

    def get_app_type(self):
        if self.interval != datetime.time(0, 0, 0):
            app_type = 'interval'
        else:
            app_type = 'max'
        return app_type

    def get_timelist(self):
        ts = self.start
        tf = datetime.datetime(self.start.year, self.start.month, self.start.day, self.finish.hour, self.finish.minute)
        # delta = tf-ts
        # div = delta.seconds / ((self.interval.minute * 60) + (self.interval.hour * 3600) + self.interval.second)
        sec = ((self.interval.minute * 60) + (self.interval.hour * 3600) + self.interval.second)
        strtimes = []
        while ts < tf:
            strtimes.append(ts.strftime('%H:%M'))
            ts += datetime.timedelta(seconds=sec)
        otimes = []
        for q in QueueRecord.objects.filter(appointment=self.id).values_list('time', flat=True):
            otimes.append(q)
        dates_list = [datetime.datetime.strptime(time, '%H:%M').time() for time in strtimes]
        ftimes = [item for item in dates_list if item not in otimes]
        return ftimes

    def get_left(self):
        left = 0
        if self.get_app_type() == "max":
            at_the_moment = QueueRecord.objects.filter(appointment=self.id).count()
            left = Appointment.objects.get(id=self.id).max - at_the_moment
        elif self.get_app_type() == "interval":
            left = len(self.get_timelist())
        return left

    class Meta:
        verbose_name = "Приём"
        verbose_name_plural = "Приёмы"
        ordering = ['-start']

    def __str__(self):
        return f'{self.start.strftime("%d.%m.%y %H:%M")} {self.name}'


class QueueRecord(models.Model):
    appointment = models.ForeignKey(Appointment, on_delete=models.CASCADE, verbose_name='Приём')
    category = models.ForeignKey(Category, on_delete=models.CASCADE, verbose_name='Категория')
    subject = models.ForeignKey(Subject, on_delete=models.CASCADE, verbose_name='Предмет')
    student = models.ForeignKey(Student, on_delete=models.CASCADE, verbose_name='Студент')
    created_time = models.DateTimeField(auto_now_add=True, verbose_name='Время записи')
    time = models.TimeField(verbose_name='Время в очереди')
    number = models.SmallIntegerField(verbose_name='Номер в очереди', default=0)
    MARK_CHOICES = [('b', 'Явился'), ('x', 'Не явился'), ('z', 'Зачёт'), ('n', 'Незачёт'), ('3', 'Удовл.'),
                    ('4', 'Хорошо'), ('5', 'Отлично')]
    mark = models.CharField(choices=MARK_CHOICES, max_length=1, blank=True, verbose_name='Отметка')
    remote_address = models.GenericIPAddressField(editable=False, null=True, default=None)

    class Meta:
        verbose_name = "Очередь"
        verbose_name_plural = "Очереди"
        ordering = ['time', 'number', 'created_time']
        unique_together = (("appointment", "student", "category", "subject"),)

    def __str__(self):
        return f'{self.appointment.start} {self.appointment.name}' \
               f' {self.student.group} {self.student.last_name} {self.student.first_name}'

django/appointment/forms.py
from dal import autocomplete
from django import forms

from people.models import Student, Tutor, Teacher, Group
from .models import QueueRecord, Appointment


class RecordForm(forms.Form):
    last_name = forms.CharField(max_length=32, widget=forms.TextInput(attrs={'class': 'form-control'}))
    first_name = forms.CharField(max_length=32, widget=forms.TextInput(attrs={'class': 'form-control'}))
    group = forms.ModelChoiceField(queryset=Group.objects.all(),
                                   widget=autocomplete.ModelSelect2(url='appointment:group-autocomplete'))


class AppointmentForm(forms.ModelForm):
    class Meta:
        model = Appointment
        fields = ['available', 'teachers', 'tutors', 'start', 'finish', 'interval', 'max', 'instruction',
                  'categories', 'subjects']
        widgets = {
            'available': forms.CheckboxInput(),
            'teachers': forms.SelectMultiple(attrs={'class': 'form-control'}),
            'tutors': forms.SelectMultiple(attrs={'class': 'form-control'}),
            'start': forms.DateTimeInput(attrs={'class': 'form-control'}),
            'finish': forms.TimeInput(attrs={'class': 'form-control'}),
            'interval': forms.TimeInput(attrs={'class': 'form-control'}),
            'max': forms.NumberInput(attrs={'class': 'form-control', 'min': 0, 'max': 1024}),
            'instruction': forms.Textarea(attrs={'class': 'form-control', 'rows': 10}),
            'categories': forms.SelectMultiple(attrs={'class': 'form-control'}),
            'subjects': forms.SelectMultiple(attrs={'class': 'form-control'})
        }


class QueueForm(forms.ModelForm):
    class Meta:
        model = QueueRecord
        fields = ['category', 'subject', 'student', 'time', 'number', 'mark', ]
        widgets = {
            'category': forms.Select(attrs={'class': 'form-control'}),
            'subject': forms.Select(attrs={'class': 'form-control'}),
            'student': forms.Select(attrs={'class': 'form-control'}),
            'mark': forms.Select(attrs={'class': 'form-control'}),
        }

django/appointment/templates/appointment/appointment_details.html
{% extends 'appointment/index.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "appointment/css/appointment.css" %}">
  {{ form.media.css }}
{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb appointment "appointment:appointment_details" appointment.id %}
{% endblock %}
{% block title %}
  {% if appointment %}
    {{ appointment }}
  {% else %}
    Электронная очередь
  {% endif %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      {% if perms.appointment.change_appointment %}
        <a href="/admin/appointment/appointment/{{ appointment.id }}/change/" class="btn btn-warning"
           role="button"><i class="fas fa-users-cog"></i> Изменить</a>
        <a href="{% url 'appointment:queue_list' appointment_id %}" class="btn btn-warning"
           role="button"> Список записавшихся</a>
        {#            <a href="{% url 'appointment:edit_appointment' appointment.id %}"><i class="far fa-edit"></i></a>#}
        <hr>
      {% endif %}
      {#    {% if perms.appointment.change_queue %}#}
      {#      <a href="{% url 'appointment:queue' appointment.id %}" role="button" class="btn btn-warning">Очередь</a>#}
      {#    {% endif %}#}
      <h1>{{ appointment.event.name }}</h1>
      <h2>{{ appointment.start.day }}.{{ appointment.start.month }}.{{ appointment.start.year }} {{ appointment.get_weekday }}</h2>
      <h2>{{ appointment.start.time }}-{{ appointment.finish }}</h2>
      {% if appointment.teachers.all.count == 1 %}
        <h3>Преподаватель:<br>
          <a href="{% url 'main:teacher'  appointment.teachers.first.id %}">{{ appointment.teachers.first }}</a><br>
        </h3>
      {% elif appointment.teachers.all.count > 1 %}
        <h3>Преподаватели:<br>
          {% for tchr in appointment.teachers.all %}
            <a href="{% url 'main:teacher' tchr.id %}">{{ tchr }}</a><br>
          {% endfor %}
        </h3>
      {% endif %}
      {% if appointment.tutors.all.count == 1 %}
        <h3>Тьютор:<br>
          {{ appointment.tutors.first.last_name }} {{ appointment.tutors.first.first_name }}
          <br>
        </h3>
      {% elif appointment.tutors.all.count > 1 %}
        <h3>Тьюторы:<br>
          {% for ttr in appointment.tutors.all %}
            {{ ttr.last_name }} {{ ttr.first_name }}<br>
          {% endfor %}
        </h3>
      {% endif %}
      {% if appointment.instruction %}
        <hr>
        {{ appointment.instruction|linebreaks }}
      {% endif %}

      <h5><span class="badge badge-secondary">
                    Мест осталось: <span class="badge badge-light">{{ appointment.get_left }}</span>
      </span></h5>
      <hr>
      <form action="{% url 'appointment:appointment_details' appointment.id %}" method="post">
        {% csrf_token %}
        <div class="form-row">
          {% if appointment.categories.all %}
            <div class="form-group col-md-6">
              <label for="id_category">Тип:</label>
              <select name="category" required class="form-control" id="id_category">
                <option></option>
                {% for cat in appointment.categories.all %}
                  <option>{{ cat }}</option>
                {% endfor %}
              </select>
            </div>
          {% endif %}
          {% if appointment.subjects.all %}
            <div class="form-group col-md-6">
              <label for="id_subject">Предмет:</label>
              <select name="subject" required class="form-control" id="id_subject">
                <option value=""></option>
                {% for sub in appointment.subjects.all %}
                  <option value="{{ sub }}">{{ sub }}</option>
                {% endfor %}
              </select>
            </div>
          {% endif %}
          <div class="form-group col-md-6">
            {{ form.last_name.errors }}
            <label for="id_last_name">Фамилия:</label>
            {{ form.last_name }}
          </div>
          <div class="form-group col-md-6">
            {{ form.first_name.errors }}
            <label for="id_first_name">Имя:</label>
            {{ form.first_name }}
          </div>
          <div class="form-group col-md-6">
            {{ form.group.errors }}
            <label for="id_group">Группа:</label>
            {{ form.group }}
          </div>
          {#          <div class="form-group col-md-6">#}
          {#            <label for="id_group">Группа</label>#}
          {#            <input type="text" name="group" class="form-control" maxlength="128" required="" id="id_group">#}
          {#          </div>#}
          {% if appointment.get_app_type == 'interval' and appointment.get_timelist %}
            <div class="form-group col-md-6">
              <label for="id_time">Выберите конкретное время:</label>
              <select class="form-control" name="time" id="id_time">
                {% for t in appointment.get_timelist %}
                  <option>{{ t }}</option>
                {% endfor %}
              </select>
            </div>
          {% else %}
            {#<p>Конкретное время выбрать нельзя.</p>#}
          {% endif %}
          {% if occupied %}
            <p id="warn_text">{{ occupied }} только-что занял кто-то другой, выберите другое время.</p>
          {% endif %}
        </div>
        <button type="submit" class="btn btn-primary">Записаться</button>
      </form>
    </div>
  </section>
{% endblock %}
{% block js %}
  {{ form.media.js }}
{% endblock %}

django/appointment/templates/appointment/edit_appointment.html
{% extends 'appointment/index.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "appointment/css/appointment.css" %}">
  <link rel="stylesheet" href="{% static "appointment/css/edit_appointment.css" %}">
  <link rel="stylesheet" href="{% static "main/npm/css/selectize.default.css" %}">
{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% if appointment_id %}
    {% breadcrumb appointment "appointment:appointment" appointment.id %}
  {% endif %}
  {% breadcrumb 'Редактирование' "" %}
{% endblock %}
{% block title %}
  {% if appointment %}
    {{ appointment }}
  {% else %}
    Электронная очередь
  {% endif %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      {% if appointment_id %}
        <form action="{% url 'appointment:edit_appointment' appointment_id %}" method="post">
      {% else %}
        <form action="{% url 'appointment:add_appointment' %}" method="post">
      {% endif %}
      {% csrf_token %}

      <div class="form-group">
        {{ form.available.errors }}
        <label for="id_available">{{ form.available.label_tag }}</label>
        {{ form.available }}
      </div>

      <div class="form-group">
        {{ form.event.errors }}
        <label for="id_event">{{ form.event.label_tag }}</label>
        {{ form.event }}
      </div>

      <div class="form-group">
        {{ form.teachers.errors }}
        <label for="id_teachers">{{ form.teachers.label_tag }}</label>
        {{ form.teachers }}
      </div>

      <div class="form-group">
        {{ form.tutors.errors }}
        <label for="id_tutors">{{ form.tutors.label_tag }}</label>
        {{ form.tutors }}
      </div>

      <div class="form-group">
        {{ form.start.errors }}
        <label for="id_start">{{ form.start.label_tag }}</label>
        {{ form.start }}
      </div>

      <div class="form-group">
        {{ form.finish.errors }}
        <label for="id_finish">{{ form.finish.label_tag }}</label>
        {{ form.finish }}
      </div>

      <div class="form-group">
        {{ form.interval.errors }}
        <label for="id_interval">{{ form.interval.label_tag }}</label>
        {{ form.interval }}
      </div>

      <div class="form-group">
        {{ form.max.errors }}
        <label for="id_max">{{ form.max.label_tag }}</label>
        {{ form.max }}
      </div>

      <div class="form-group">
        {{ form.instruction.errors }}
        <label for="id_instruction">{{ form.instruction.label_tag }}</label>
        {{ form.instruction }}
      </div>

      <div class="form-group">
        {{ form.categories.errors }}
        <label for="id_categories">{{ form.categories.label_tag }}</label>
        {{ form.categories }}
      </div>

      <div class="form-group">

        {{ form.subjects.errors }}
        <label for="id_subjects">{{ form.subjects.label_tag }}</label>
        {{ form.subjects }}

      </div>
      <button type="submit" class="btn btn-primary">Сохранить</button>
      </form>
    </div>
  </section>
{% endblock %}
{% block js %}
  <script src="{% static "main/npm/js/selectize.min.js" %}"></script>
  <script src="{% static "appointment/js/appointment.js" %}"></script>
  {{ form.media }}
{% endblock %}

django/appointment/templates/appointment/errors.html
{% extends 'main/base.html' %}
{% block content %}
  {% if occupied %}
    занято
  {% elif over %}
    Очередь заполнилась.

  {% else %}
    что-то пошло не так
  {% endif %}
{% endblock %}

django/appointment/templates/appointment/index.html
{% extends 'main/base.html' %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Электронная очередь" "appointment:index" %}
{% endblock %}
{% block title %}Электронная очередь{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      {% if perms.appointment.add_appointment %}
        <a href="/admin/appointment/appointment/add/" class="btn btn-warning"
           role="button"><i class="fas fa-users-cog"></i> Добавить</a>
        {#                    <a href="{% url 'appointment:add_appointment' %}" class="btn btn-primary btn-block"#}
        {#                       role="button">Добавить</a>#}
        <hr>
      {% endif %}

      {% if appointments %}
        <div class="list-group">
          {% for appointment in appointments %}
            <a href="/appointments/{{ appointment.pk }}" class="list-group-item list-group-item-action">
              <p>{{ appointment.event.name }}</p>
              <p>{{ appointment.start.day }}.{{ appointment.start.month }} {{ appointment.get_weekday }} {{ appointment.start.time }}</p>
              <h5><span class="badge badge-secondary">
                    Мест осталось: <span class="badge badge-light">{{ appointment.get_left }}</span>
              </span></h5>
            </a>
          {% endfor %}
        </div>
      {% else %}
        <p>Назначенных очередей нет.</p>
      {% endif %}
    </div>
  </section>
{% endblock %}

django/appointment/templates/appointment/queue_list.html
{% extends 'appointment/appointment_details.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "appointment/css/appointment.css" %}">
{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb 'Список записавшихся' "" %}
{% endblock %}
{% block title %}
  {% if appointment %}
    {{ appointment }} - Список записавшихся
  {% else %}
    Электронная очередь
  {% endif %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <a href="{% url 'appointment:queue_list_export' appointment.id %}" class="btn btn-warning"
       role="button">xls</a>
    <hr>
    <table class="table table-sm table-striped table-bordered">
      <thead>
      <tr>
        <th scope="col">#</th>
        <th scope="col">Студент</th>
        <th scope="col">Время записи</th>
        <th scope="col">Номер</th>
        <th scope="col">Время приёма</th>
        <th scope="col">Категория</th>
        <th scope="col">Предмет</th>
        <th scope="col">Отметка</th>
      </tr>
      </thead>
      <tbody>

      {% for queue in queue_list %}
        <tr>
          <th scope="row">{{ forloop.counter }}<br>
            <a href="{% url 'appointment:delete_queue_record' appointment.id queue.id %}"
               title="Удалить" onclick="return confirm('Удалить {{ queue.student.last_name }}?')">
              <i class="fas fa-user-minus"></i></a></th>
          <td>
            {{ queue.student.last_name }} {{ queue.student.first_name }} {{ queue.student.middle_name }}<br> {{ queue.student.group }}
          </td>
          <td>{{ queue.created_time }}</td>
          <td>{{ queue.number }}</td>
          <td>{{ queue.time }}</td>
          <td>{{ queue.category }}</td>
          <td>{{ queue.subject }}</td>
          <td>{{ queue.get_mark_display }}</td>
        </tr>
      {% endfor %}
      </tbody>
    </table>

    {#        {% if appointment_id %}#}
    {#            <form action="{% url 'appointment:edit_appointment' appointment_id %}" method="post">#}
    {#        {% else %}#}
    {#            <form action="{% url 'appointment:add_appointment' %}" method="post">#}
    {#        {% endif %}#}
    {#        {% csrf_token %}#}
    {##}
    {#        <div class="form-group">#}
    {#            {{ form.available.errors }}#}
    {#            <label for="id_available">{{ form.available.label_tag }}</label>#}
    {#            {{ form.available }}#}
    {#        </div>#}
    {##}
    {##}
    {#        <button type="submit" class="btn btn-primary">Сохранить</button>#}
    {#        </form>#}
  </section>
{% endblock %}
{% block js %}
  {{ form.media }}
{% endblock %}

django/appointment/templates/appointment/result.html
{% extends 'appointment/index.html' %}
{% load static %}
{% block css %}
  <link rel="stylesheet" href="{% static "appointment/css/appointment.css" %}">
  {{ form.media.css }}
{% endblock %}
{% load django_bootstrap_breadcrumbs %}
{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb appointment "appointment:appointment" appointment.id %}
{% endblock %}
{% block title %}
  {% if appointment %}
    {{ appointment }}
  {% else %}
    Электронная очередь
  {% endif %}
{% endblock %}
{% block content %}
  {% render_breadcrumbs %}
  <section class="container-fluid flex-grow">
    <div class="container">
      <h1>{{ appointment.event.name }}</h1>
      <h2>{{ appointment.start.day }}.{{ appointment.start.month }}.{{ appointment.start.year }} {{ appointment.get_weekday }}</h2>
      <h2>{{ appointment.start.time }}-{{ appointment.finish }}</h2>
      {% if appointment.teachers.all.count == 1 %}
        <h3>Преподаватель:<br>
          <a href="{% url 'main:teacher'  appointment.teachers.first.id %}">{{ appointment.teachers.first }}</a><br>
        </h3>
      {% elif appointment.teachers.all.count > 1 %}
        <h3>Преподаватели:<br>
          {% for tchr in appointment.teachers.all %}
            <a href="{% url 'main:teacher' tchr.id %}">{{ tchr }}</a><br>
          {% endfor %}
        </h3>
      {% endif %}
      {% if appointment.tutors.all.count == 1 %}
        <h3>Тьютор:<br>
          {{ appointment.tutors.first.last_name }} {{ appointment.tutors.first.first_name }}
          <br>
        </h3>
      {% elif appointment.tutors.all.count > 1 %}
        <h3>Тьюторы:<br>
          {% for ttr in appointment.tutors.all %}
            {{ ttr.last_name }} {{ ttr.first_name }}<br>
          {% endfor %}
        </h3>
      {% endif %}
      {% if appointment.instruction %}
        <hr>
        {{ appointment.instruction|linebreaks }}
      {% endif %}

      <h5><span class="badge badge-secondary">
                    Мест осталось: <span class="badge badge-light">{{ appointment.get_left }}</span>
      </span></h5>
      <hr>
      {% if decision == 'success' %}
        <div class="alert alert-success" role="alert">
          Вы в очереди.
        </div>
      {% elif decision == 'repeatedly' %}
        <div class="alert alert-danger" role="alert">
          Такая запись уже есть. Можно записаться на другой тип и/или предмет.
        </div>
      {% elif decision == 'full' %}
        <div class="alert alert-warning" role="alert">
          Места закончились. Скорее всего, через неделю будет новая очередь.
        </div>
      {% elif decision == 'taked' %}
        <div class="alert alert-warning" role="alert">
          Это время только-что занял кто-то другой, выберите другое.
        </div>
      {% endif %}


    </div>
  </section>
{% endblock %}
{% block js %}
  {{ form.media.js }}
{% endblock %}